#if !defined LIB_MISC_TONEMAPS
#define LIB_MISC_TONEMAPS
    /*
        Tone maps and such that are not large enough to be in their own file go here.
    */
    vec3 TonemapHejlBurgess(in vec3 color) {
        color = max(vec3(0.0), color - 0.0008);
        color = (color * (6.2 * color + 0.5)) / (color * (6.2 * color + 1.7) + 0.06);

        return color;
    }

    const float overlapRG = 0.15;
    const float overlapRB = 0.02;
    const float overlapGB = 0.05;
    const mat3 m = mat3(
        1.0 - overlapRG - overlapRB, overlapRG, overlapRB,
        overlapRG, 1.0 - overlapRG - overlapGB, overlapGB,
        overlapRB, overlapGB, 1.0 - overlapRB - overlapGB
    );
#endif