#if !defined RNG_BAYER
#define RNG_BAYER
    float Bayer32(vec2 a) {
        uvec2 b = uvec2(a);
        uint c = (b.x^b.y)<<1u;
        return float(
            ((c&32u|b.y&16u)>>4u)|
            ((c&16u|b.y&8u)>>1u)|
            ((c&8u|b.y&4u)<<2u)|
            ((c&4u|b.y&2u)<<5u)|
            ((c&2u|b.y&1u)<<8u)
        )/1024.;
    }

    float BayerAnimated(in vec2 coord) {
        return fract(fract(frameCounter * (1.0 / phi)) + Bayer32(coord));
    }
#endif